{% extends "base/base.html" %}

{% load static %}

{% load myfilter %}

{% block content %}

<h1 class="text-center">Add new software</h1>

<p class="text-center">
    Add a new software to the "Softwares sheets" list. If you selected a software in "All answers" it will pre-fill the fields.
    Submitting the form will also create a new repository about this software in the
    <a href="https://gitlab.com/soleil-data-treatment/soleil-software-documentation"
        title="https://gitlab.com/soleil-data-treatment/soleil-software-documentation" target="_blank"
        rel="noopener noreferrer">
        soleil-software-documentation gitlab</a>.
</p>

{% if messages %}
<ul class="messages container">
    {% for message in messages %}
    <div{% if message.tags %} class="blink_animation alert alert-dismissible alert-{{ message.tags }}"{% endif %}>
        <button type="button" class="close" data-dismiss="alert">&times;</button>
        <strong>{{ message.tags }}</strong>{{ message }}
    </div>
    {% endfor %}
</ul>
{% endif %}

<!--
<form form action="" method='POST' enctype="multipart/form-data" novalidate accept-charset="utf-8">
    <div class="form-group">
        <label for="softwareName">Software Name</label>
        <input id="softwareName" class="form-control mx-sm-3" aria-describedby="softwareNameHelpBlock">
        <small id="softwareNameHelpBlock" class="text-muted">
            Must be at maximum 40 characters long. Please enter a valid software name. You can check if the name exists on websites like 
            <a href="https://software.pan-data.eu"
            title="https://software.pan-data.eu" target="_blank"
            rel="noopener noreferrer">
            https://software.pan-data.eu</a>.
        </small>
    </div>
    <div class="form-group">
        <label for="gridCheck1">Gitlab repository</label>
        <div class="form-check">
            <input class="form-check-input" type="checkbox" id="gridCheck1">
                <label class="form-check-label" for="gridCheck1">
                    Create a repository in gitlab
                </label>
        </div>
    </div>
    <div class="form-group">
        <label for="FormControlFile1">Data set</label>
        <input type="file" class="form-control-file" id="FormControlFile1">
        <small id="FormControlFile1" class="text-muted">
            You can add data sets about this software.
        </small>
    </div>
    <div class="form-group row">
        <div class="col-sm-10">
            <button type="submit" class="btn btn-primary">Add the software</button>
        </div>
    </div>
</form>
-->

{% block head_extra %}
<script src="{% static 'markdownparser/jquery-3.3.1.slim.min.js' %}"></script>
<script src="{% static 'markdownparser/src/active-type.min.js' %}"></script>
<style>
.blink_animation {
    animation: blinker 1s linear 0.5s;
  }
  
  @keyframes blinker {  
    50% { opacity: 0; }
  }

.preview {
    background: rgba(219, 219, 219, 0.329);
    border-radius: .25rem;
}
.grayed {
    background: rgba(219, 219, 219, 0.329);
}
</style>
{% endblock head_extra %}

<div class="container">
        <form class="needs-validation" action="" method='POST' enctype="multipart/form-data" novalidate accept-charset="utf-8" >

        <div class="container">
            <div class="row row-no-gutters">
                <div class="col-sm-6">
                    <h3>Enter these fields:</h3>
                </div>
                <div class="col-sm-6">
                    <h3>Preview:</h3>
                </div>
            <div class="row row-no-gutters" aria-describedby="form-input-help">
                <div class="col-sm-6">
                    {% csrf_token %}
                    {{ form }}
                    <small id="form-input-help" class="form-text text-muted">A Gitlab repo will be created by clicking on "Add the software". The repo's name will be one word in "Software" input. Please use only one word otherwise make sure to add "-" characters for example, instead of spaces if you want to use more than one word.</small>
                </div>
                <div class="col-sm-6 preview">
                    <label>Software:</label>
                    <div class="form-control list-group-item mb-3 d-flex align-items-center grayed" id="software-input-preview"></div>
                    <label>Markdown content preview:</label>
                    <div id="content-input-preview"></div>
                </div>
            </div>
        </div>
            <button type="submit" class="btn btn-success btn-lg mt-3">Add the software</button>
        </form>
</div>

{% block javascript_extra %}
<script type="text/javascript">

// JavaScript for software's name viewer
$("#software-input").keyup(function() {
  $("#software-input-preview").html(this.value.replace(/\n/g, '<br/>'));
});

// JavaScript for markdown parser
var activeType = $("#content-input").activeType({
    preview_selector:'#content-input-preview'
});

activeType.refresh();

jQuery.fn.extend({
  autoHeight: function () {
    function autoHeight_(element) {
      return jQuery(element)
        .css({ 'height': 'auto', 'overflow-y': 'hidden' })
        .height(element.scrollHeight);
    }
    return this.each(function() {
      autoHeight_(this).on('input', function() {
        autoHeight_(this);
      });
    });
  }
});
$('textarea').autoHeight();

// JavaScript for disabling form submissions if there are invalid fields
(function() {
  'use strict';
  window.addEventListener('load', function() {
    // Fetch all the forms we want to apply custom Bootstrap validation styles to
    var forms = document.getElementsByClassName('needs-validation');
    // Loop over them and prevent submission
    var validation = Array.prototype.filter.call(forms, function(form) {
      form.addEventListener('submit', function(event) {
        if (form.checkValidity() === false) {
          event.preventDefault();
          event.stopPropagation();
        }
        form.classList.add('was-validated');
      }, false);
    });
  }, false);
})();

</script>
{% endblock javascript_extra %}

{% endblock %}